/**
 * Copyright (c) 2015-2016  Telinc1
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
package com.telinc1.nfls.field;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class FieldBoolean extends Field {
    private boolean data;

    public FieldBoolean(){
        this(false);
    }

    public FieldBoolean(boolean data){
        this.setData(data);
    }

    public boolean getData(){
        return this.data;
    }

    public void setData(boolean data){
        this.data = data;
    }

    @Override
    public byte getType(){
        return Field.FIELD_BOOLEAN;
    }

    @Override
    public void writeToStream(DataOutputStream stream) throws IOException {
        stream.writeBoolean(this.getData());
    }

    @Override
    public void readFromStream(DataInputStream stream) throws IOException {
        this.setData(stream.readBoolean());
    }
}
