/**
 * Copyright (c) 2015-2016  Telinc1
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
package com.telinc1.nfls.field.decimal;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import com.telinc1.nfls.field.Field;

public class FieldFloat extends Field {
    private float data;

    public FieldFloat(){
        this(-1);
    }

    public FieldFloat(float data){
        this.setData(data);
    }

    public float getData(){
        return this.data;
    }

    public void setData(float data){
        this.data = data;
    }

    @Override
    public byte getType(){
        return Field.FIELD_FLOAT;
    }

    @Override
    public void writeToStream(DataOutputStream stream) throws IOException {
        stream.writeFloat(this.getData());
    }

    @Override
    public void readFromStream(DataInputStream stream) throws IOException {
        this.setData(stream.readFloat());
    }
}
