/**
 * Copyright (c) 2015-2016  Telinc1
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
package com.telinc1.nfls.field.decimal.array;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import com.telinc1.nfls.field.Field;

public class FieldDoubleArray extends Field {
    private double[] data;

    public FieldDoubleArray(){
        this.setData(null);
    }
    
    public FieldDoubleArray(short length){
        this(new double[length]);
    }

    public FieldDoubleArray(double[] data){
        this.setData(data);
    }

    public double[] getData(){
        return this.data;
    }

    public void setData(double[] data){
        this.data = data;
    }

    @Override
    public byte getType(){
        return Field.FIELD_DOUBLE_ARRAY;
    }

    @Override
    public void writeToStream(DataOutputStream stream) throws IOException {
        stream.writeShort(this.getData().length);

        for(double value : this.getData()){
            stream.writeDouble(value);
        }
    }

    @Override
    public void readFromStream(DataInputStream stream) throws IOException {
        double[] data = new double[stream.readShort()];

        for(int i = 0; i < data.length; i++){
            data[i] = stream.readDouble();
        }

        this.setData(data);
    }
}
