/**
 * Copyright (c) 2015-2016  Telinc1
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
package com.telinc1.nfls.field.decimal.array;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import com.telinc1.nfls.field.Field;

public class FieldFloatArray extends Field {
    private float[] data;

    public FieldFloatArray(){
        this.setData(null);
    }

    public FieldFloatArray(short length){
        this(new float[length]);
    }

    public FieldFloatArray(float[] data){
        this.setData(data);
    }

    public float[] getData(){
        return this.data;
    }

    public void setData(float[] data){
        this.data = data;
    }

    @Override
    public byte getType(){
        return Field.FIELD_FLOAT_ARRAY;
    }

    @Override
    public void writeToStream(DataOutputStream stream) throws IOException {
        stream.writeShort(this.getData().length);

        for(float value : this.getData()){
            stream.writeFloat(value);
        }
    }

    @Override
    public void readFromStream(DataInputStream stream) throws IOException {
        float[] data = new float[stream.readShort()];

        for(int i = 0; i < data.length; i++){
            data[i] = stream.readFloat();
        }
    }
}
