/**
 * Copyright (c) 2015-2016  Telinc1
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
package com.telinc1.nfls.field.integer;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import com.telinc1.nfls.field.Field;

public class FieldByte extends Field {
    private byte data;

    public FieldByte(){
        this((byte)-1);
    }

    public FieldByte(byte data){
        this.setData(data);
    }

    public byte getData(){
        return this.data;
    }

    public void setData(byte data){
        this.data = data;
    }

    @Override
    public byte getType(){
        return Field.FIELD_BYTE;
    }

    @Override
    public void writeToStream(DataOutputStream stream) throws IOException {
        stream.writeByte(this.getData());
    }

    @Override
    public void readFromStream(DataInputStream stream) throws IOException {
        this.setData(stream.readByte());
    }
}
