/**
 * Copyright (c) 2015-2016  Telinc1
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
package com.telinc1.nfls.field.integer.array;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import com.telinc1.nfls.field.Field;

public class FieldByteArray extends Field {
    private byte[] data;

    public FieldByteArray(){
        this.setData(null);
    }

    public FieldByteArray(short length){
        this(new byte[length]);
    }

    public FieldByteArray(byte[] data){
        this.setData(data);
    }

    public byte[] getData(){
        return this.data;
    }

    public void setData(byte[] data){
        this.data = data;
    }

    @Override
    public byte getType(){
        return Field.FIELD_BYTE_ARRAY;
    }

    @Override
    public void writeToStream(DataOutputStream stream) throws IOException {
        stream.writeShort(this.getData().length);

        for(byte value : this.getData()){
            stream.writeByte(value);
        }
    }

    @Override
    public void readFromStream(DataInputStream stream) throws IOException {
        byte[] data = new byte[stream.readShort()];

        for(int i = 0; i < data.length; i++){
            data[i] = stream.readByte();
        }
    }
}
