/**
 * Copyright (c) 2015-2016  Telinc1
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
package com.telinc1.nfls.field.integer.array;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import com.telinc1.nfls.field.Field;

public class FieldShortArray extends Field {
    private short[] data;

    public FieldShortArray(){
        this.setData(null);
    }

    public FieldShortArray(short length){
        this(new short[length]);
    }

    public FieldShortArray(short[] data){
        this.setData(data);
    }

    public short[] getData(){
        return this.data;
    }

    public void setData(short[] data){
        this.data = data;
    }

    @Override
    public byte getType(){
        return Field.FIELD_SHORT_ARRAY;
    }

    @Override
    public void writeToStream(DataOutputStream stream) throws IOException {
        stream.writeShort(this.getData().length);

        for(short value : this.getData()){
            stream.writeShort(value);
        }
    }

    @Override
    public void readFromStream(DataInputStream stream) throws IOException {
        short[] data = new short[stream.readShort()];

        for(int i = 0; i < data.length; i++){
            data[i] = stream.readShort();
        }
        
        this.setData(data);
    }
}
