/**
 * Copyright (c) 2015-2016  Telinc1
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
package com.telinc1.nfls.field.integer.array;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import com.telinc1.nfls.field.Field;

public class FieldString extends Field {
    private String data;

    public FieldString(){
        this.setData((String)null);
    }

    public FieldString(short length){
        this(new char[length]);
    }

    public FieldString(String data){
        this.setData(data);
    }

    public FieldString(char[] data){
        this(data.toString());
    }

    public String getData(){
        return this.data;
    }

    public void setData(String data){
        this.data = data;
    }

    public void setData(char[] data){
        this.setData(new String(data));
    }

    @Override
    public byte getType(){
        return Field.FIELD_STRING;
    }

    @Override
    public void writeToStream(DataOutputStream stream) throws IOException {
        stream.writeShort(this.getData().length());
        stream.writeBytes(this.getData());
    }

    @Override
    public void readFromStream(DataInputStream stream) throws IOException{
        StringBuilder builder = new StringBuilder(); // Can't do it otherwise.
        short length = stream.readShort();

        for(int i = 0; i < length; i++){
            builder.append((char)stream.readByte());
        }

        this.setData(builder.toString());
    }
}
